// generated from file '../src/faust/peak_eq.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)


namespace peak_eq {

class Dsp: public PluginDef {
private:
	int fSamplingFreq;
	int 	iConst0;
	double 	fConst1;
	FAUSTFLOAT 	fslider0;
	FAUSTFLOAT 	fslider1;
	double 	fConst2;
	double 	fConst3;
	FAUSTFLOAT 	fslider2;
	double 	fConst4;
	FAUSTFLOAT 	fslider3;
	FAUSTFLOAT 	fslider4;
	FAUSTFLOAT 	fslider5;
	FAUSTFLOAT 	fslider6;
	FAUSTFLOAT 	fslider7;
	double 	fRec3[3];
	FAUSTFLOAT 	fslider8;
	FAUSTFLOAT 	fslider9;
	double 	fRec2[3];
	FAUSTFLOAT 	fslider10;
	FAUSTFLOAT 	fslider11;
	double 	fRec1[3];
	double 	fRec0[3];
	void clear_state_f();
	int load_ui_f(const UiBuilder& b, int form);
	void init(unsigned int samplingFreq);
	void compute(int count, float *input0, float *output0);
	int register_par(const ParamReg& reg);

	static void clear_state_f_static(PluginDef*);
	static int load_ui_f_static(const UiBuilder& b, int form);
	static void init_static(unsigned int samplingFreq, PluginDef*);
	static void compute_static(int count, float *input0, float *output0, PluginDef*);
	static int register_params_static(const ParamReg& reg);
	static void del_instance(PluginDef *p);
public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginDef() {
	version = PLUGINDEF_VERSION;
	flags = 0;
	id = "eq";
	name = N_("Peak EQ");
	groups = 0;
	description = ""; // description (tooltip)
	category = N_("Tone control");       // category
	shortname = "";     // shortname
	mono_audio = compute_static;
	stereo_audio = 0;
	set_samplerate = init_static;
	activate_plugin = 0;
	register_params = register_params_static;
	load_ui = load_ui_f_static;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<3; i++) fRec3[i] = 0;
	for (int i=0; i<3; i++) fRec2[i] = 0;
	for (int i=0; i<3; i++) fRec1[i] = 0;
	for (int i=0; i<3; i++) fRec0[i] = 0;
}

void Dsp::clear_state_f_static(PluginDef *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(unsigned int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (3.141592653589793 / iConst0);
	fConst2 = double((1.0 / iConst0));
	fConst3 = (3.141592653589793 * fConst2);
	fConst4 = (6.283185307179586 * fConst2);
	clear_state_f();
}

void Dsp::init_static(unsigned int samplingFreq, PluginDef *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void always_inline Dsp::compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = tan((fConst1 * fSlow0));
	double 	fSlow2 = (1.0 / fSlow1);
	double 	fSlow3 = fslider1;
	int 	iSlow4 = int((fSlow3 > 0));
	double 	fSlow5 = fslider2;
	double 	fSlow6 = sin((fConst4 * fSlow0));
	double 	fSlow7 = (fConst3 * ((fSlow5 * pow(10,(0.05 * fabs(fSlow3)))) / fSlow6));
	double 	fSlow8 = (fConst3 * (fSlow5 / fSlow6));
	double 	fSlow9 = ((iSlow4)?fSlow7:fSlow8);
	double 	fSlow10 = (1 + (fSlow2 * (fSlow9 + fSlow2)));
	double 	fSlow11 = fslider3;
	double 	fSlow12 = tan((fConst1 * fSlow11));
	double 	fSlow13 = (2 * (1 - (1.0 / faustpower<2>(fSlow12))));
	double 	fSlow14 = fslider4;
	double 	fSlow15 = tan((fConst1 * fSlow14));
	double 	fSlow16 = (2 * (1 - (1.0 / faustpower<2>(fSlow15))));
	double 	fSlow17 = fslider5;
	double 	fSlow18 = tan((fConst1 * fSlow17));
	double 	fSlow19 = (2 * (1 - (1.0 / faustpower<2>(fSlow18))));
	double 	fSlow20 = (1.0 / fSlow18);
	double 	fSlow21 = fslider6;
	int 	iSlow22 = int((fSlow21 > 0));
	double 	fSlow23 = fslider7;
	double 	fSlow24 = sin((fConst4 * fSlow17));
	double 	fSlow25 = (fConst3 * (fSlow23 / fSlow24));
	double 	fSlow26 = (fConst3 * ((fSlow23 * pow(10,(0.05 * fabs(fSlow21)))) / fSlow24));
	double 	fSlow27 = ((iSlow22)?fSlow25:fSlow26);
	double 	fSlow28 = (1 + (fSlow20 * (fSlow20 - fSlow27)));
	double 	fSlow29 = (1 + (fSlow20 * (fSlow27 + fSlow20)));
	double 	fSlow30 = ((iSlow22)?fSlow26:fSlow25);
	double 	fSlow31 = (1 + (fSlow20 * (fSlow30 + fSlow20)));
	double 	fSlow32 = (1 + (fSlow20 * (fSlow20 - fSlow30)));
	double 	fSlow33 = (1.0 / fSlow15);
	double 	fSlow34 = fslider8;
	int 	iSlow35 = int((fSlow34 > 0));
	double 	fSlow36 = fslider9;
	double 	fSlow37 = sin((fConst4 * fSlow14));
	double 	fSlow38 = (fConst3 * (fSlow36 / fSlow37));
	double 	fSlow39 = (fConst3 * ((fSlow36 * pow(10,(0.05 * fabs(fSlow34)))) / fSlow37));
	double 	fSlow40 = ((iSlow35)?fSlow38:fSlow39);
	double 	fSlow41 = (1 + (fSlow33 * (fSlow33 - fSlow40)));
	double 	fSlow42 = (1 + (fSlow33 * (fSlow40 + fSlow33)));
	double 	fSlow43 = ((iSlow35)?fSlow39:fSlow38);
	double 	fSlow44 = (1 + (fSlow33 * (fSlow43 + fSlow33)));
	double 	fSlow45 = (1 + (fSlow33 * (fSlow33 - fSlow43)));
	double 	fSlow46 = (1.0 / fSlow12);
	double 	fSlow47 = fslider10;
	int 	iSlow48 = int((fSlow47 > 0));
	double 	fSlow49 = fslider11;
	double 	fSlow50 = sin((fConst4 * fSlow11));
	double 	fSlow51 = (fConst3 * (fSlow49 / fSlow50));
	double 	fSlow52 = (fConst3 * ((fSlow49 * pow(10,(0.05 * fabs(fSlow47)))) / fSlow50));
	double 	fSlow53 = ((iSlow48)?fSlow51:fSlow52);
	double 	fSlow54 = (1 + (fSlow46 * (fSlow46 - fSlow53)));
	double 	fSlow55 = (1 + (fSlow46 * (fSlow53 + fSlow46)));
	double 	fSlow56 = ((iSlow48)?fSlow52:fSlow51);
	double 	fSlow57 = (1 + (fSlow46 * (fSlow56 + fSlow46)));
	double 	fSlow58 = (1 + (fSlow46 * (fSlow46 - fSlow56)));
	double 	fSlow59 = ((iSlow4)?fSlow8:fSlow7);
	double 	fSlow60 = (1 + (fSlow2 * (fSlow2 - fSlow59)));
	double 	fSlow61 = (2 * (1 - (1.0 / faustpower<2>(fSlow1))));
	double 	fSlow62 = (1 + (fSlow2 * (fSlow59 + fSlow2)));
	double 	fSlow63 = (1 + (fSlow2 * (fSlow2 - fSlow9)));
	for (int i=0; i<count; i++) {
		double fTemp0 = (fSlow19 * fRec3[1]);
		fRec3[0] = ((double)input0[i] - (((fSlow28 * fRec3[2]) + fTemp0) / fSlow29));
		double fTemp1 = (fSlow16 * fRec2[1]);
		fRec2[0] = ((((fTemp0 + (fSlow31 * fRec3[0])) + (fSlow32 * fRec3[2])) / fSlow29) - (((fSlow41 * fRec2[2]) + fTemp1) / fSlow42));
		double fTemp2 = (fSlow13 * fRec1[1]);
		fRec1[0] = ((((fTemp1 + (fSlow44 * fRec2[0])) + (fSlow45 * fRec2[2])) / fSlow42) - (((fSlow54 * fRec1[2]) + fTemp2) / fSlow55));
		double fTemp3 = (fSlow61 * fRec0[1]);
		fRec0[0] = ((((fTemp2 + (fSlow57 * fRec1[0])) + (fSlow58 * fRec1[2])) / fSlow55) - (((fSlow60 * fRec0[2]) + fTemp3) / fSlow62));
		output0[i] = (FAUSTFLOAT)((((fSlow10 * fRec0[0]) + fTemp3) + (fSlow63 * fRec0[2])) / fSlow62);
		// post processing
		fRec0[2] = fRec0[1]; fRec0[1] = fRec0[0];
		fRec1[2] = fRec1[1]; fRec1[1] = fRec1[0];
		fRec2[2] = fRec2[1]; fRec2[1] = fRec2[0];
		fRec3[2] = fRec3[1]; fRec3[1] = fRec3[0];
	}
}

void __rt_func Dsp::compute_static(int count, float *input0, float *output0, PluginDef *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, output0);
}

int Dsp::register_par(const ParamReg& reg)
{
	reg.registerVar("eq.bandwidth1","","S",N_("bandwidth (hz)"),&fslider7, 41.0, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth2","","S",N_("bandwidth (hz)"),&fslider9, 2.2e+02, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth3","","S",N_("bandwidth (hz)"),&fslider11, 8.8e+02, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth4","","S",N_("bandwidth (hz)"),&fslider2, 1.76e+03, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.level1","","S",N_("gain (dB)"),&fslider6, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level2","","S",N_("gain (dB)"),&fslider8, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level3","","S",N_("gain (dB)"),&fslider10, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level4","","S",N_("gain (dB)"),&fslider1, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.peak1","","S",N_("frequency (hz)"),&fslider5, 1.1e+02, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak2","","S",N_("frequency (hz)"),&fslider4, 4.4e+02, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak3","","S",N_("frequency (hz)"),&fslider3, 1.76e+03, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak4","","S",N_("frequency (hz)"),&fslider0, 3.52e+03, 2e+01, 2.2e+04, 1.0);
	return 0;
}

int Dsp::register_params_static(const ParamReg& reg)
{
	return static_cast<Dsp*>(reg.plugin)->register_par(reg);
}

inline int Dsp::load_ui_f(const UiBuilder& b, int form)
{
    if (form & UI_FORM_STACK) {
#define PARAM(p) ("eq" "." p)
b.openHorizontalhideBox("");
b.closeBox();
b.openHorizontalTableBox("");
{
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level1"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak1"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth1"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level2"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak2"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth2"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level3"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak3"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth3"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level4"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak4"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth4"), _("bandwidth"));
    }
    b.closeBox();
}
b.closeBox();

#undef PARAM
        return 0;
    }
	return -1;
}

int Dsp::load_ui_f_static(const UiBuilder& b, int form)
{
	return static_cast<Dsp*>(b.plugin)->load_ui_f(b, form);
}
PluginDef *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginDef *p)
{
	delete static_cast<Dsp*>(p);
}

} // end namespace peak_eq
